#!/bin/sh
#
# bbdef.sh
#
# BIG BROTHER DEFINITIONS AREA
# Sean MacGuire - The MacLawran Group Inc.
# Version 1.2a
# May 4th, 1999
#
# This program is Copyright (c) 1997-1999
# The MacLawran Group Inc.
# All Rights Reserved
#


#
# NEW FOR 1.04... DISPLAY FULLY QUALIFED DOMAIN NAMES?
# i.e. aaa.bbb.com instead of just aaa
#
# FQDN="TRUE"		# YES...

FQDN=""


#
# SMM NEW FOR 1.07C
# CONFIGURATION FOR bb-network.sh
# USE lynx IF YOU MUST TEST PASSWORD PROTECTED PAGES
# LIKE Leif Ericksen <phantom@wwa.com>
# LYNX="/usr/local/bin/lynx -dump -head"

LYNX="$BBHOME/bin/bbnet"	        # WHERE bbnet LIVES


#
# INTERNET SERVICES YOU DON'T WANT TO GET PAGED ON
# WHEN THEY'RE DOWN... ASSUMPTION IS YOU WANT TO KNOW 
# ABOUT EVERYTHING RIGHT NOW... (pop3/smtp/ssh/...)
#

NONETPAGE=""
export NONETPAGE


#
# WHERE tmp FILES LIVE - THIS IS GOOD FOR SECURITY
# THANKS TO Alan Cox (alan@cymru.net)
#

BBTMP="$BBHOME/tmp"
export BBTMP


#
# LOCAL CLIENT MONITORING CONFIGURATION FOR bb-local.sh
#
# WARNING AND PANIC LEVELS FOR LOCAL SYSTEM INFOMRAION
#

DFWARN=90				# (YELLOW) DISK % TO WARN
DFPANIC=95				# (RED) DISK % TO PANIC
export DFWARN DFPANIC


#
# CPU LEVELS ARE THE 5 MINUTE LOAD AVERAGE x 100
#

CPUWARN=150				# (YELLOW) WARN AT LOAD AVG OF 1.5
CPUPANIC=300				# (RED) PANIC AT LOAD AVG OF 3
export CPUPANIC CPUWARN


#
# PROCESS MONITORING
#

PROCS="sendmail bbd"			# (YELLOW) WARN IF ONE OF THESE NOT RUNNING 
PAGEPROC="http"				# (RED) PAGE IF ONE OF THESE NOT RUNNING
export PROCS PAGEPROC


#
# MESSAGE FILE MONITORING (/var/adm/messages or similar)
#

MSGS="NOTICE WARNING"			# (YELLOW) MESSAGES TO WATCH FOR 
PAGEMSG="NOTICE"			# (RED) PAGE IF WE SEE THIS MESSAGE
IGNMSGS=""              # List of messages to ignore if string(s) matches line
                        # delimit each message with ;
export MSGS PAGEMSG IGNMSGS


# 
# PATH TO WEB SERVER DISPLAY
# INSERT THE PATH TO YOUR BBDISPLAY WEB SERVER
# THIS IS USED ONLY IF YOU USE HTMLized STATUS LOGS
#

BBWEBHTMLLOGS="http://put.your.www.host.here.find.it.in.bbdef.sh/bb/html/"
export BBWEBHTMLLOGS


#
# Default colors to send notification messages on
#
PAGELEVELS="red purple"                 # Default red purple
                                        # purple is always sent by the
                                        # BBDISPLAY. Clients shouldn't
                                        # send purple
export PAGELEVELS                       # Will be overidden in bbinc.sh
                                        # with values found in
                                        # etc/bbwarnsetup.cfg

#
# GENERATE WEB BASED HISTORY OR USE HISTORY LOG FILE
#
WEBHISTORY="TRUE"
export WEBHISTORY
 
. ${BBHOME}/etc/bbsys.sh		# INCLUDE SYSTEM DEFINITIONS
. ${BBHOME}/etc/bbinc.sh		# INCLUDE BB DEFINITIONS

export FQDN DF MSGFILE LYNX
