#!/bin/sh
#
# BIG BROTHER WEB BASED MANUAL NOTIFICATION ACKNOWLEDGEMENT SCRIPT
# Sean MacGuire - The MacLawran Group Inc.
# Version 1.2a
# May 4th, 1999
#
# This program is Copyright (c) 1997-1999
# The MacLawran Group Inc.
# All Rights Reserved
#

#
# ************* NOTICE!!! ************
# BBHOME MUST BE SET CORRECTLY FOR THIS TO WORK

BBHOME=""; export BBHOME
if test "$BBHOME" = ""
then
        echo "Content-type: text/html


                <HTML><BODY>
                <H1>ERROR!<BR>BBHOME IS NOT SET IN bb-ack.sh</H1></BODY>
                </HTML>"
        exit 1
fi

#
# ************* NOTICE!!! ************
# BBWEB MUST BE SET CORRECTLY FOR THIS TO WORK

#BBWEB="http://INSERT-WEB-HOST-HERE/bb/";
BBWEB="http://node83.cdrom.com/bb/";


. $BBHOME/etc/bbdef.sh


# Are we called from a web page ?
if [ "$QUERY_STRING" != "" ]
then


    set `echo $QUERY_STRING | sed "s/[&=]/\ /g"`
    while [ "$#" -ne 0 ]
    do
	# echo "$# $*" >> /tmp/YYY
        case $1 in
	ACTION )	ACTION=`echo "$2" | $SED 's/[^A-Za-z]//g'`
			shift 2
			;;
	NUMBER )	NUMBER=`echo "$2" | $SED 's/[^0-9]//g'`
			if test "$NUMBER" != "DELAY"
			then
				shift 2
			else 
				NUMBER=""
				shift
			fi
			;;
	DELAY )		DELAY=`echo "$2" | $SED 's/[^0-9]//g'`
			if test "$DELAY" = ""
			then
				DELAY=60	# DUMB DEFAULT
			fi
			shift
			;;
	MESSAGE )
		# MESSAGE MIGHT BE NULL
		case "$2" in
		NUMBER | DELAY )
			shift
			;;
		* )
			MESSAGE="$2"
			shift 2
			;;
		esac
		;;
	*)		shift
			;;
	esac
    done

    echo "Content-type: text/html

    <BASE HREF=$BBWEB>

    <HTML>
    <TITLE>Big Brother Systems and Network Monitor</TITLE>
    <BODY bgcolor=\"#000000\" background=\"gifs/bkg-red.gif\" link=\"#FFFFFF\"
    vlink=\"#FF0000\" text=\"#00FFFF\">
    <IMG SRC=\"gifs/bb.gif\" ALIGN=RIGHT>
    <H1>Big Brother - Paging & Acknowledgement
    <H3>A Web-based Systems and Network Monitoring <BR>
    and Notification System</H3>
    <H4>Version 1.2a - May 4th 1999</H4>
    <P><H2><I><BR><BR>"
else
    if [ "$#" -lt 2 -o "$#" -gt 3 ]
    then
	echo "usage: bb-ack.sh <ticket #> <delay> [message]"
	exit 1
    fi
    NUMBER=`echo "$1" | $SED 's/[^0-9]//g'`
    DELAY=`echo "$2" | $SED 's/[^0-9]//g'`
    ACTION="Ack"
    if [ "$#" -eq 3 ]
    then
	MESSAGE="$3"
    else
	MESSAGE=""
    fi
fi

if [ "$ACTION" = "Ack" ]
then
	# Thanks to Peter.Bosmans@is.belgacom.be
	# Was sending stderr to a file !
	CHKNUM=`expr "$NUMBER" + 0` 2>/dev/null
	if [ "$NUMBER" != "$CHKNUM"  -o "$CHKNUM" = "" ]
	then
    	# Are we called from a web page ?
    	if [ "$QUERY_STRING" != "" ]
    	then
        	echo "Invalid security code $NUMBER<BR>"
        	echo "</I></H2></BODY></HTML>"
    	else
        	echo "usage: bb-ack.sh <ticket #> <delay> [message]"
    	fi
    	exit 1
	fi
	
	CHKDELAY=`expr "$DELAY" + 0`
	if [ "$DELAY" != "$CHKDELAY" -o "$CHKDELAY" = "" ]
	then
    	# Are we called from a web page ?
    	if [ "$QUERY_STRING" != "" ]
    	then
		echo "Invalid delay: \"$DELAY\"<BR>$QUERY_STRING<BR>"
		echo "</I></H2></BODY></HTML>"
    	else
        	echo "usage: bb-ack.sh <ticket #> <delay> [message]"
    	fi
    	exit 1
	fi
	

	$BB $BBPAGE "ack ack_event ${NUMBER} ${DELAY} ${MESSAGE}"
	echo "An acknowledgement for notification event ${NUMBER} <BR>with a ${DELAY} minute delay has been sent"

elif [ "$ACTION" = "Page" ]
then
	if test "$MESSAGE" = ""
	then
		echo "Blank message... no page sent"
	else
		# Don't change the notify-admin.pagehelp name or suffer the consequences !
		$BB $BBPAGE "page notify-admin.pagehelp ${MESSAGE} User has requested your help.  Call ${MESSAGE}"
		echo "You have sent a page to the admin.<BR>You will be contacted shortly!"
	fi
fi

# Are we called from a web page ?
if [ "$QUERY_STRING" != "" ]
then
    echo "</I></H2></BODY></HTML>"
fi

exit 0
