#!/bin/sh
#
# BIG BROTHER WEB BASED HISTORY DISPLAY SCRIPT
# Robert-Andre Croteau
# Version 1.2a
# May 4th, 1999
#
# This program is Copyright (c) 1997-1999
# The MacLawran Group Inc.
# All Rights Reserved
#

# ************* NOTICE!!! ************
# BBWEB MUST BE SET CORRECTLY FOR THIS TO WORK
#
#BBWEB="http://INSERT-WEB-HOST-HERE/bb/"
BBWEB="http://node83.cdrom.com/bb/"
export BBWEB

# BBHOME IS THE ROOT DIRECTORY OF BIG BROTHER!!!
# YOU MUST SET THE NEXT LINE TO WHERE BB LIVES
BBHOME=""
export BBHOME           

if test "$BBHOME" = ""
then
    	echo "Content-type: text/html

		
		<HTML><BODY>
		<H1>ERROR!<BR>BBHOME IS NOT SET IN bb-hist.sh</H1></BODY>
		</HTML>"
	exit 1
fi


. $BBHOME/etc/bbdef.sh


# Are we called from a web page ?
if [ "$QUERY_STRING" != "" ]
then

    HISTFILE="HISTFILE_NOT_DEFINED"
    set `echo $QUERY_STRING | $SED 's/[&=]/\ /g' | $SED 's/%2C/,/g'`
    while [ "$#" -ne 0 ]
    do
	# echo "$# $*" >> /tmp/YYY
        case $1 in
	HISTFILE )	HISTFILE="$2"
			shift 2
			;;
	BKG )		BKG="$2"
			shift 2
			if [ "$BKG" = "clear" ]
			then
				bkgcolor="white"
			else
				bkgcolor="$BKG"
			fi
			;;
	*)		shift
			;;
	esac
    done

    # Take the basename only !!!
    # 
    OLDIFS=$IFS
    IFS='/'
    set $HISTFILE
    IFS=$OLDIFS
    lastarg="\$$#"
    HISTFILE=`eval "echo $lastarg"`
    HISTFILE=`echo "$HISTFILE" | $SED 's/[^A-Za-z0-9.\,_-]//g'`
    HOSTFILE=`echo "$HISTFILE" | $SED 's/\,/\./g'`
    OLDIFS=$IFS
    IFS='.'
    set $HOSTFILE
    IFS=$OLDIFS
    HOSTDOTS="$1"
    HOSTCOMMAS="$1"
    shift
    while [ "$#" -gt 1 ]
    do
	HOSTDOTS=${HOSTDOTS}.$1
	HOSTCOMMAS=${HOSTCOMMAS},$1
	shift
    done
    SERVICE=$1

    echo "Content-type: text/html

<BASE HREF=$BBWEB>

<HTML>
<TITLE>Big Brother History Graph: $HOSTDOTS - $SERVICE</TITLE>
<BODY bgcolor=\"#000000\" background=\"gifs/bkg-$BKG.gif\" link=\"#FFFFFF\" vlink=\"#FFFF00\" text=\"FFFFFF\">

<P>    
<IMG SRC=\"gifs/bb.gif\" ALT=\"Big Brother\" ALIGN=RIGHT HEIGHT=166 WIDTH=176>
<FONT COLOR=\"FFFFCC\">
<H1>Big Brother - History Graph</H1>
<H3>A Web-based Systems and Network Monitoring and Notification System</H3>
<H4>Version $BBREL - $BBRELDATE</H4>
<BR><BR CLEAR=ALL></P>"

    if [ -f "$BBHOME/www/hist/$HISTFILE" ]
    then
        nowtick=`$BBHOME/bin/touchtime -e`
	daytick=`expr $nowtick - 86400`
        prevcolor="green"
        prevline=""
        firstday=TRUE
	lastline=`$TAIL -1 "$BBHOME/www/hist/$HISTFILE"`
	set $lastline >/dev/null
        lastlinecolor=$6
	lastlinetick=$7
        echo "<CENTER>
<BR>
<TABLE WIDTH=\"100%\" BORDER=0 BGCOLOR=666666>
<TR><TD>
<TABLE WIDTH=\"100%\" BORDER=1 BGCOLOR=\"\#000033\">
<TR>
<TD WIDTH=\"50%\" ALIGN=LEFT><B>`$BBHOME/bin/touchtime -a -1440`</B></TD>
<TD WIDTH=\"50%\" ALIGN=RIGHT><B>`$BBHOME/bin/touchtime -a`</B></TD>
</TR>
</TABLE>
<TABLE WIDTH=\"100%\" BORDER=0 BGCOLOR=\"\#000033\">"
        starthr=`$DATE +"%H"`
        if [ "$starthr" -eq 23 ]
        then
            starthr=0
        else
            starthr=`expr $starthr + 1`
        fi
        i=0
        echo "<TR>"
        minmod=`expr $nowtick % 3600 / 60`
        quarters=`expr \( $minmod / 15 \) + 1`
        startquarters=`expr 4 - $quarters`
        if [ "$startquarters" -gt 0 ]
        then
            starthr=`expr $starthr - 1`
            if [ "$starthr" -eq -1 ]
            then
                starthr=23
            fi
            echo "<TD WIDTH=${startquarters}%><B>&nbsp</B></TD>"
            starthr=`expr \( $starthr + 1 \) % 24`
            i=`expr $i + 1`
        fi
        if [ "$startquarters" -eq 0 ]
        then
            loops=23
        else
            loops=24
        fi
        while [ "$i" -lt $loops ]
        do
            echo "<TD WIDTH=4% ALIGN=LEFT><B>$starthr</B></TD>"
            starthr=`expr \( $starthr + 1 \) % 24`
            i=`expr $i + 1`
        done
        quarters=`expr "$quarters" + 1`
        echo "<TD WIDTH=${quarters}% ALIGN=LEFT><B>$starthr</B></TD>"
        echo "</TR>"
        echo "</TABLE>"
        echo "<TABLE WIDTH=100% BORDER=0 BGCOLOR=\"\#000033\">"
        echo "<TR>"
        greenticks=0
        yellowticks=0
        redticks=0
        purpleticks=0
        clearticks=0
        if [ "$lastlinetick" -lt "$daytick" ]
        then
            echo "<TD WIDTH=\"100%\" BGCOLOR=\"$bkgcolor\" NOWRAP>&nbsp</TD>"
            evalstr="${lastlinecolor}ticks=86400"
            eval "$evalstr"
        else
	TMPFILE="/tmp/BBHIST.$$"
        $CAT "$BBHOME/www/hist/$HISTFILE" | \
        while read line
        do
            set $line >/dev/null
            if [ "$#" -ge 7 ]
            then
                if [ "$6" = "clear" ]
                then
                    color=white
                else
                    color=$6
                fi
                if [ "$7" -ge "$daytick" ]
                then
                    if [ "$firstday" = TRUE ]
                    then
			headdayticks=`expr $7 - $daytick`
                        firstday=FALSE
                        if [ "$headdayticks" -ne 0 ]
                        then
                            perc=`expr 100 \* $headdayticks / 86400`
                            if [ "$perc" -eq 0 ]
                            then
                                perc=1
                            fi
                            evalstr="${prevcolor}ticks=\`expr \$${prevcolor}ticks + $headdayticks\`"
                            eval "$evalstr"
                            echo "<TD WIDTH="$perc%" BGCOLOR=$prevcolor NOWRAP>&nbsp</TD>"
                        fi
                    fi
                    if [ "$#" -gt 7 ]
                    then
                        headdayticks=$8
                    else
                        headdayticks=`expr $nowtick - $7`
                    fi
                    perc=`expr 100 \* $headdayticks / 86400`
                    if [ "$perc" -eq 0 ]
                    then
                        perc=1
                    elif [ "$perc" -gt 10 ]
                    then
                        perc=`expr "$perc" - 1` # hack to readjust colored blocks
                    fi
                    evalstr="${color}ticks=\`expr \$${color}ticks + $headdayticks\`"
                    eval "$evalstr"
                    echo "<TD WIDTH="$perc%" BGCOLOR=$color NOWRAP>&nbsp</TD>"
                    if [ "$#" -eq 7 ]
                    then
                           $RM -f $TMPFILE
                           echo "greenticks=${greenticks};yellowticks=${yellowticks};redticks=${redticks};purpleticks=${purpleticks};clearticks=${clearticks}" > $TMPFILE
                    fi
                fi
	        prevline="$line"
                prevcolor=$color
            fi
        done
        fi
        echo "</TR>
</TABLE>

</TD></TR></TABLE>

<BR><H1>$HOSTDOTS - $SERVICE</H1></FONT>
<TABLE BORDER=1 BGCOLOR=\"333333\">
<TR>
<TD ALIGN=CENTER COLSPAN=5><B>24 Hrs Summary</B></TD>
</TR>
<TR>"
	echo "<TD ALIGN=CENTER><IMG SRC=\"gifs/green.gif\" ALT=\"green\" HEIGHT=12 WIDTH=12 BORDER=0></TD>
<TD ALIGN=CENTER><IMG SRC=\"gifs/yellow.gif\" ALT=\"yellow\" HEIGHT=12 WIDTH=12 BORDER=0></TD>
<TD ALIGN=CENTER><IMG SRC=\"gifs/red.gif\" ALT=\"red\" HEIGHT=12 WIDTH=12 BORDER=0></TD>
<TD ALIGN=CENTER><IMG SRC=\"gifs/purple.gif\" ALT=\"purple\" HEIGHT=12 WIDTH=12 BORDER=0></TD>
<TD ALIGN=CENTER><IMG SRC=\"gifs/clear.gif\" ALT=\"clear\" HEIGHT=12 WIDTH=12 BORDER=0></TD>
</TR>
<TR>"
        if [ -f "$TMPFILE" ]
        then
            evalstr=`$CAT "${TMPFILE}"`
            $RM -f "$TMPFILE"
            eval "$evalstr"
        fi
        if [ "$greenticks" -ne 0 ]
        then
            greenperc=`expr $greenticks \* 100 / 86400`
            if [ "$greenperc" -eq 0 ]
            then
                greenperc=1
            fi
        else
            greenperc=0
        fi
        if [ "$yellowticks" -ne 0 ]
        then
            yellowperc=`expr $yellowticks \* 100 / 86400`
            if [ "$yellowperc" -eq 0 ]
            then
                yellowperc=1
            fi
        else
            yellowperc=0
        fi
        if [ "$redticks" -ne 0 ]
        then
            redperc=`expr $redticks \* 100 / 86400`
            if [ "$redperc" -eq 0 ]
            then
                redperc=1
            fi
        else
            redperc=0
        fi
        if [ "$purpleticks" -ne 0 ]
        then
            purpleperc=`expr $purpleticks \* 100 / 86400`
            if [ "$purpleperc" -eq 0 ]
            then
                purpleperc=1
            fi
        else
            purpleperc=0
        fi
        if [ "$clearticks" -ne 0 ]
        then
            clearperc=`expr $clearticks \* 100 / 86400`
            if [ "$clearperc" -eq 0 ]
            then
                clearperc=1
            fi
        else
            clearperc=0
        fi
        echo "<TD ALIGN=CENTER><B>${greenperc}%</B></TD>
<TD ALIGN=CENTER><B>${yellowperc}%</B></TD>
<TD ALIGN=CENTER><B>${redperc}%</B></TD>
<TD ALIGN=CENTER><B>${purpleperc}%</B></TD>
<TD ALIGN=CENTER><B>${clearperc}%</B></TD>
</TR>
<TR> <TD COLSPAN=5><B>* Total may not be 100%</B></TD> </TR>
</TABLE>
</CENTER>"
      
	echo "<BR><BR>
<CENTER>
<TABLE BORDER=1 BGCOLOR=\"\#333333\">
<TR>
<TD ALIGN=CENTER COLSPAN=3><B>Last 50 log entries</B><A HREF=\"hist/$HISTFILE\"> (Full log)</A></TD>
</TR>
<TR>
<TD ALIGN=CENTER>Date</TD>
<TD ALIGN=CENTER>Status</TD>
<TD ALIGN=CENTER>Seconds</TD></TR>"

	TMPFILE="/tmp/BBHIST.$$"
	$RM -f $TMPFILE
        $SORT -r -n -k 7 "$BBHOME/www/hist/$HISTFILE" > $TMPFILE
        if [ "$?" -ne 0 ]
        then 
            echo "Your SORT command does not seem to support the \"-r -n -k 7\"<BR>"
            echo "option. It probably wants \"-r -n +7\" as the option to SORT<BR>"
            echo "please fix it in the bb-hist.sh script"
        fi
        tablesize=1
        $CAT $TMPFILE | \
	while read line
	do 
		if test "$BG" = "333333"
		then
			BG="000033"
		else
			BG="333333"
		fi
		set $line > /dev/null
		echo "<TR BGCOLOR=$BG><TD ALIGN=LEFT>$1 $2 $3 $4 $5</TD><TD ALIGN=CENTER><IMG SRC=\"gifs/$6.gif\" HEIGHT=12 WIDTH=12 ALT=\"$6\"></TD><TD ALIGN=CENTER>$8</TD></TR>"
                if [ "$tablesize" -gt 50 ]
                then
                    break
                else
                    tablesize=`expr "$tablesize" + 1`
                fi
	done
        $RM -f $TMPFILE
	echo "</TABLE>
<BR>
</CENTER>"
    else
        echo "<H2>Error reading history file [$HISTFILE]</H2>"
    fi
    echo "<BR>
<A HREF=\"http://MacLawran.ca/bb-dnld/\">
<IMG SRC=\"gifs/bbbut.gif\" ALT=\"Get Big Brother\" HEIGHT=31 WIDTH=88 ALIGN=RIGHT BORDER=0></A>"

    echo "</BODY></HTML>"
fi

exit 0
